Merge branch 'en/merge-path-collision'
[git.git] / t / Makefile
blobc83fd18861f31039bc14ec71a9a897b03359b2c7
1 # Run tests
3 # Copyright (c) 2005 Junio C Hamano
6 -include ../config.mak.autogen
7 -include ../config.mak
9 #GIT_TEST_OPTS = --verbose --debug
10 SHELL_PATH ?= $(SHELL)
11 TEST_SHELL_PATH ?= $(SHELL_PATH)
12 PERL_PATH ?= /usr/bin/perl
13 TAR ?= $(TAR)
14 RM ?= rm -f
15 PROVE ?= prove
16 DEFAULT_TEST_TARGET ?= test
17 TEST_LINT ?= test-lint
19 ifdef TEST_OUTPUT_DIRECTORY
20 TEST_RESULTS_DIRECTORY = $(TEST_OUTPUT_DIRECTORY)/test-results
21 CHAINLINTTMP = $(TEST_OUTPUT_DIRECTORY)/chainlinttmp
22 else
23 TEST_RESULTS_DIRECTORY = test-results
24 CHAINLINTTMP = chainlinttmp
25 endif
27 # Shell quote;
28 SHELL_PATH_SQ = $(subst ','\'',$(SHELL_PATH))
29 TEST_SHELL_PATH_SQ = $(subst ','\'',$(TEST_SHELL_PATH))
30 PERL_PATH_SQ = $(subst ','\'',$(PERL_PATH))
31 TEST_RESULTS_DIRECTORY_SQ = $(subst ','\'',$(TEST_RESULTS_DIRECTORY))
32 CHAINLINTTMP_SQ = $(subst ','\'',$(CHAINLINTTMP))
34 T = $(sort $(wildcard t[0-9][0-9][0-9][0-9]-*.sh))
35 TGITWEB = $(sort $(wildcard t95[0-9][0-9]-*.sh))
36 THELPERS = $(sort $(filter-out $(T),$(wildcard *.sh)))
37 CHAINLINTTESTS = $(sort $(patsubst chainlint/%.test,%,$(wildcard chainlint/*.test)))
38 CHAINLINT = sed -f chainlint.sed
40 all: $(DEFAULT_TEST_TARGET)
42 test: pre-clean check-chainlint $(TEST_LINT)
43 $(MAKE) aggregate-results-and-cleanup
45 failed:
46 @failed=$$(cd '$(TEST_RESULTS_DIRECTORY_SQ)' && \
47 grep -l '^failed [1-9]' *.counts | \
48 sed -n 's/\.counts$$/.sh/p') && \
49 test -z "$$failed" || $(MAKE) $$failed
51 prove: pre-clean check-chainlint $(TEST_LINT)
52 @echo "*** prove ***"; $(PROVE) --exec '$(TEST_SHELL_PATH_SQ)' $(GIT_PROVE_OPTS) $(T) :: $(GIT_TEST_OPTS)
53 $(MAKE) clean-except-prove-cache
55 $(T):
56 @echo "*** $@ ***"; '$(TEST_SHELL_PATH_SQ)' $@ $(GIT_TEST_OPTS)
58 pre-clean:
59 $(RM) -r '$(TEST_RESULTS_DIRECTORY_SQ)'
61 clean-except-prove-cache: clean-chainlint
62 $(RM) -r 'trash directory'.* '$(TEST_RESULTS_DIRECTORY_SQ)'
63 $(RM) -r valgrind/bin
65 clean: clean-except-prove-cache
66 $(RM) .prove
68 clean-chainlint:
69 $(RM) -r '$(CHAINLINTTMP_SQ)'
71 check-chainlint:
72 @mkdir -p '$(CHAINLINTTMP_SQ)' && \
73 err=0 && \
74 for i in $(CHAINLINTTESTS); do \
75 $(CHAINLINT) <chainlint/$$i.test | \
76 sed -e '/^# LINT: /d' >'$(CHAINLINTTMP_SQ)'/$$i.actual && \
77 diff -u chainlint/$$i.expect '$(CHAINLINTTMP_SQ)'/$$i.actual || err=1; \
78 done && exit $$err
80 test-lint: test-lint-duplicates test-lint-executable test-lint-shell-syntax \
81 test-lint-filenames
83 test-lint-duplicates:
84 @dups=`echo $(T) | tr ' ' '\n' | sed 's/-.*//' | sort | uniq -d` && \
85 test -z "$$dups" || { \
86 echo >&2 "duplicate test numbers:" $$dups; exit 1; }
88 test-lint-executable:
89 @bad=`for i in $(T); do test -x "$$i" || echo $$i; done` && \
90 test -z "$$bad" || { \
91 echo >&2 "non-executable tests:" $$bad; exit 1; }
93 test-lint-shell-syntax:
94 @'$(PERL_PATH_SQ)' check-non-portable-shell.pl $(T) $(THELPERS)
96 test-lint-filenames:
97 @# We do *not* pass a glob to ls-files but use grep instead, to catch
98 @# non-ASCII characters (which are quoted within double-quotes)
99 @bad="$$(git -c core.quotepath=true ls-files 2>/dev/null | \
100 grep '["*:<>?\\|]')"; \
101 test -z "$$bad" || { \
102 echo >&2 "non-portable file name(s): $$bad"; exit 1; }
104 aggregate-results-and-cleanup: $(T)
105 $(MAKE) aggregate-results
106 $(MAKE) clean
108 aggregate-results:
109 for f in '$(TEST_RESULTS_DIRECTORY_SQ)'/t*-*.counts; do \
110 echo "$$f"; \
111 done | '$(SHELL_PATH_SQ)' ./aggregate-results.sh
113 gitweb-test:
114 $(MAKE) $(TGITWEB)
116 valgrind:
117 $(MAKE) GIT_TEST_OPTS="$(GIT_TEST_OPTS) --valgrind"
119 perf:
120 $(MAKE) -C perf/ all
122 .PHONY: pre-clean $(T) aggregate-results clean valgrind perf check-chainlint clean-chainlint